/**/
#include <stdlib.h>
#include <string.h>

#include <splitter.h>
#include "wordborder.h"

extern allocator anthy_seginfo_ator;

static struct seg_info *
init_seginfo(struct meta_word *mw)
{
  mw->si = anthy_smalloc(anthy_seginfo_ator);
  mw->si->cand.str = 0;
  mw->si->word_info = 0;
  mw->si->nr_word_info = 0;
  mw->si->core_word_info_index = -1;
  mw->si->info_len = 0;
  mw->si->struct_ratio = RATIO_BASE;
  mw->si->score = 0;
  mw->si->seg_class = mw->seg_class;
  return mw->si;
}

/** seginfoword_listƤɲä
 */
static void
seginfo_pushback_word_list(struct seg_info *si,
			   struct word_list *wl)
{
  int i;
  /* word_listƤpartФ */
  for (i = 0; i < NR_PARTS; i++) {
    struct part_info *part = &wl->part[i];
    if (part->len == 0) {
      /* Ĺ̵part̵뤹 */
      continue ;
    }
    if (i == PART_CORE) {
      si->core_word_info_index = si->nr_word_info;
    }
    /* Ƥ򥳥ԡ */
    si->word_info = realloc(si->word_info,
			    (si->nr_word_info+1) * sizeof(struct word_info));
    si->word_info[si->nr_word_info].wt = part->wt;
    si->word_info[si->nr_word_info].len = part->len;
    si->word_info[si->nr_word_info].ratio = part->ratio;
    si->info_len += part->len;
    si->nr_word_info ++;
  }
}

/** seginfo¤ɾ
 */
static int
eval_seginfo_by_struct(struct seg_info *si)
{
  int len = si->info_len;
  int uncover = len - si->info_len;
  int i;
  int ratio = RATIO_BASE;

  /* seginfoʤХǥեȤ */
  if (!si->nr_word_info) {
    return ratio;
  }

  /* seginfoǥСƤΰγ礬礭ۤɥ礭 */
  if (uncover > 7) {
    /* Ĺ°줬Ĥ */
    uncover = 7;
  }
  /* °줬2ʸʤиʤ */
  uncover -= 2;
  if (uncover < 0) {
    uncover = 0;
  }
  ratio *= (RATIO_BASE - uncover * (RATIO_BASE/16));
  ratio /= RATIO_BASE;
  
  /* ʬνŤߤ򤫤 */
  for (i = 0; i < si->nr_word_info; i++) {
    ratio *= si->word_info[i].ratio;
    ratio /= RATIO_BASE;
  }

  if (ratio == 0) {
    ratio = 1;
  }
  return ratio;
}

/** 礵줿metawordseg_infoФ */
static struct seg_info *
get_seginfo_from_combined_metaword(struct meta_word *mw)
{
  struct seg_info *si;
  si = init_seginfo(mw);
  si->type = SI_NORMAL;
  seginfo_pushback_word_list(si, mw->mw1->wl);
  seginfo_pushback_word_list(si, mw->mw2->wl);

  si->struct_ratio = eval_seginfo_by_struct(mw->si);
  si->struct_ratio *= mw->mw2->wl->part[PART_DEPWORD].ratio;
  si->struct_ratio /= RATIO_BASE;

  return si;
}

/** ޤwordlistmetawordseg_infoФ */
static struct seg_info *
get_seginfo_from_simple_metaword(struct meta_word *mw)
{
  struct seg_info *si;
  struct word_list *wl = mw->wl;
  si = init_seginfo(mw);
  si->type = SI_NORMAL;

  /* Ƭ, Ω, , ° */
  seginfo_pushback_word_list(si, wl);

  /* ¤ɾ */
  si->struct_ratio = eval_seginfo_by_struct(mw->si);

  /* °ΥѥФ륹 */
  si->struct_ratio *= wl->part[PART_DEPWORD].ratio;
  si->struct_ratio /= RATIO_BASE;
  /* Ωγѷˤ륹 */
  si->struct_ratio *= wl->part[PART_CORE].ratio;
  si->struct_ratio /= RATIO_BASE;
  return si;
}

/**
 * metawordʸФ
 */
static struct seg_info *
get_seginfo_from_metaword(struct meta_word *mw)
{
  struct seg_info *si;

  /* ǤˤФ֤ */
  if (mw->si) {
    return mw->si;
  }
  /* ̵ΤǺ */

  /* ޤwordlistmetawordξ */
  if (mw->wl && mw->wl->len) {
    return get_seginfo_from_simple_metaword(mw);
  }

  /* metawordΥפˤäƼФѤ */
  switch (anthy_metaword_type_tab[mw->type].si) {
  case MW_SEGINFO_WRAPPED:
    /* wrap줿ΤξФ */
    return get_seginfo_from_metaword(mw->mw1);
  case MW_SEGINFO_COMBINED:
    /* 2ʸ */
    return get_seginfo_from_combined_metaword(mw);
  case MW_SEGINFO_OCHAIRE_LEAF:
    /* ؽˤ */
    si = init_seginfo(mw);
    si->type = SI_CAND;
    si->cand.str = anthy_xstr_dup_str(mw->cand_hint);
    si->cand.len = mw->cand_hint->len;
    /* seginfoĹmetawordĹ */
    si->info_len = mw->len;
    eval_seginfo_by_struct(mw->si);
    return si;
  case MW_SEGINFO_NONE:
    /* seginfoʤ */
    break;
  default:
    break;
  }
  return 0;
}

/** from,lenΰ򥫥Сseg_info */
int
anthy_get_nr_seginfo(struct splitter_context *sc,
		     int from, int len)
{
  struct meta_word *mw;
  int n;

  for (n = 0, mw = sc->word_split_info->cnode[from].mw;
       mw; mw = mw->next) {
    if (mw->len == len) {
      if (get_seginfo_from_metaword(mw)) {
	n++;
      }
    }
  }
  return n;
}

struct seg_info *
anthy_get_nth_seginfo(struct splitter_context *sc,
		      int from, int len, int nth)
{
  struct meta_word *mw;
  int n;
  for (n = 0, mw = sc->word_split_info->cnode[from].mw;
       mw; mw = mw->next) {
    if (mw->len == len) {
      struct seg_info *si = get_seginfo_from_metaword(mw);
      if (si) {
	if (n == nth) {
	  return si;
	}
	n++;
      }
    }
  }
  return NULL;
}
